(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     12789,        367]*)
(*NotebookOutlinePosition[     13494,        391]*)
(*  CellTagsIndexPosition[     13450,        387]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(SetDirectory["\<C:\ITHFILES\AUSE\MATHS\working\Leuvenconf\>"]\)], \
"Input"],

Cell[BoxData[
    \("C:\\ITHFILES\\AUSE\\MATHS\\working\\Leuvenconf"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Clear["\<@\>"]\)], "Input"],

Cell[BoxData[
    \(<< numersimple.m\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[BCO[a, b, c, e, i], {i, 1, 6}]\)], "Input"],

Cell[BoxData[
    \({{\(-1\) + b . e}, {b . c}, {\(-\(1\/6\)\) + b . c + 
          2\ b . a . e, \(-\(1\/12\)\) + b . c\^2\/2}, {b . c + 6\ b . a . c, 
        b . c\^2 + 2\ b . \((c\ a . e)\), 
        b . c\^3\/6}, {\(-\(1\/15\)\) + b . c + 12\ b . a . c + 
          24\ b . a . a . e, \(-\(1\/30\)\) + 
          1\/2\ \((b . c + 12\ b . a . c\^2)\), \(-\(1\/15\)\) + b . c\^2 + 
          6\ b . \((c\ a . c)\), \(-\(1\/30\)\) + 
          1\/2\ \((b . c\^2 + 4\ b . \((c\ a . e)\) + 
                4\ b . \((a . e)\)\^2)\), \(-\(1\/30\)\) + 
          1\/2\ \((b . c\^3 + 2\ b . \((c\^2\ a . e)\))\), \(-\(1\/360\)\) + 
          b . c\^4\/24}, {b . c + 20\ b . a . c + 120\ b . a . a . c, 
        b . c + 20\ b . a . c\^2 + 40\ b . a . \((c\ a . e)\), 
        1\/6\ \((b . c + 20\ b . a . c\^3)\), 
        b . c\^2 + 12\ b . \((c\ a . c)\) + 24\ b . \((c\ a . a . e)\), 
        1\/2\ \((b . c\^2 + 12\ b . \((c\ a . c\^2)\))\), 
        b . c\^2 + 6\ b . \((c\ a . c)\) + 2\ b . \((c\ a . e)\) + 
          12\ b . \((a . c\ a . e)\), 
        1\/2\ \((b . c\^3 + 6\ b . \((c\^2\ a . c)\))\), 
        1\/2\ \((b . c\^3 + 4\ b . \((c\^2\ a . e)\) + 
              4\ b . \((c\ \((a . e)\)\^2)\))\), 
        1\/6\ \((b . c\^4 + 2\ b . \((c\^3\ a . e)\))\), 
        b . c\^5\/120}}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    StyleBox[\(a = {{0, 0, 0, 0, 0}, {0, 0, 0, 0, 0}, {a31, a32, 0, 0, 
              0}, {a41, a42, a43, 0, 0}, {a51, a52, a53, a54, 0}};\),
      FormatType->StandardForm], "\n", 
    StyleBox[\(e = {1, 1, 1, 1, 1};\),
      FormatType->StandardForm], "\n", 
    StyleBox[\(b = {b1, b2, b3, b4, b5};\),
      FormatType->StandardForm], "\n", \(c = {1, 0, c3, c4, c5};\)}], "Input"],

Cell[BoxData[
    \(\(sy = Simplify[a . e - \((1/2\ c^2 - 1/2  c)\)];\)\)], "Input"],

Cell[BoxData[
    \(\(s1 = 
        Solve[{sy[\([3]\)] \[Equal] 0, sy[\([4]\)] \[Equal] 0, 
            sy[\([5]\)] == 0}, {a31, a41, a51}];\)\)], "Input"],

Cell[BoxData[
    \(a31 = s1[\([1, 1, 2]\)]; a41 = s1[\([1, 2, 2]\)]; 
    a51 = s1[\([1, 3, 2]\)];\)], "Input"],

Cell[BoxData[
    \(\(s2 = 
        Solve[{\(-1\) + b . e \[Equal] 0, 
            b . c \[Equal] 0, \(-\(1\/12\)\) + b . c\^2\/2 \[Equal] 0, 
            b . c\^3\/6 \[Equal] 0, \(-\(1\/360\)\) + b . c\^4\/24 \[Equal] 
              0}, {b1, b2, b3, b4, b5}];\)\)], "Input"],

Cell[BoxData[
    \(b2 = s2[\([1, 1, 2]\)]; b1 = s2[\([1, 2, 2]\)]; b3 = s2[\([1, 3, 2]\)]; 
    b4 = s2[\([1, 4, 2]\)]; b5 = s2[\([1, 5, 2]\)];\)], "Input"],

Cell[BoxData[
    \(\(sy3 = 
        Simplify[
          Solve[{b . a . c \[Equal] 
                0, \(-\(1\/360\)\) + 1\/2\ b . a . c\^2 \[Equal] 0, 
              1\/60 + b . \((c\ a . c)\) \[Equal] 0, 
              1\/6\ b . a . c\^3 \[Equal] 0, 
              1\/2\ b . \((c\^2\ a . c)\) \[Equal] 0, 
              1\/144 + 1\/2\ b . \((c\ a . c\^2)\) \[Equal] 0}, {a42, a43, 
              a32, a54, a52, a53}]];\)\)], "Input"],

Cell[BoxData[
    \(a42 = sy3[\([1, 1, 2]\)]; a43 = sy3[\([1, 2, 2]\)]; 
    a32 = sy3[\([1, 3, 2]\)]; a54 = sy3[\([1, 4, 2]\)]; 
    a52 = sy3[\([1, 5, 2]\)]; a53 = sy3[\([1, 6, 2]\)];\)], "Input"],

Cell[BoxData[
    \(\(c5 = \(Solve[Simplify[b . c^5] \[Equal] 0, c5]\)[\([1, 1, 
            2]\)];\)\)], "Input"],

Cell[BoxData[
    \(a = Simplify[a]; b = Simplify[b]; c = Simplify[c];\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      Table[BCO[aa, bb, cc, ee, i], {i, 1, 6}] /. {aa \[Rule] a, 
          bb \[Rule] b, cc \[Rule] c, ee \[Rule] e}]\)], "Input"],

Cell[BoxData[
    \({{0}, {0}, {0, 0}, {0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Simplify[a . e - \((1/2\ c^2 - 1/2  c)\)];\)\)], "Input"],

Cell[BoxData[
    \(a = Simplify[a]; b = Simplify[b]; c = Simplify[c];\)], "Input"],

Cell[BoxData[
    \(\(pp = 
        Simplify[TCO[aa, bb, cc, ee, 7]] /. {aa \[Rule] a, bb \[Rule] b, 
            cc \[Rule] c, ee \[Rule] e};\)\)], "Input"],

Cell[BoxData[
    RowBox[{"(*", 
      RowBox[{
        RowBox[{
          RowBox[{
          "Known", " ", "Method", " ", "of", " ", "order", " ", "6", 
            "\[IndentingNewLine]", 
            StyleBox["a",
              FormatType->StandardForm]}], 
          StyleBox["=",
            FormatType->StandardForm], 
          
          StyleBox[\({{0, 0, 0, 0, 0}, {0, 0, 0, 0, 0}, {1/16, 5/16, 0, 0, 
                0}, {\(-7\)/144, \(-5\)/48, 1/36, 0, 0}, {\(-2\)/9, 1/3, 2/9, 
                2/3, 0}}\),
            FormatType->StandardForm]}], 
        StyleBox[";",
          FormatType->StandardForm], 
        StyleBox["\n",
          FormatType->StandardForm], 
        StyleBox[\(e = {1, 1, 1, 1, 1}\),
          FormatType->StandardForm], 
        StyleBox[";",
          FormatType->StandardForm], 
        StyleBox["\n",
          FormatType->StandardForm], 
        StyleBox[\(b = {1/60, 13/30, 4/15, 4/15, 1/60}\),
          FormatType->StandardForm], 
        StyleBox[";",
          FormatType->StandardForm], 
        "\n", \(c = {1, 0, \(-1\)/2, 1/2, \(-1\)}\), ";"}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(truncerror1 = 
      Sqrt[N[Plus @@ \((pp^2 /. {c4 \[Rule] 1/2, 
                  c3 \[Rule] \(-1\)/2})\)]]\)], "Input"],

Cell[BoxData[
    \(0.0034523041394584853`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pmin = 
      FindMinimum[Plus @@ \((pp^2)\), {c4, 0.5}, {c3, \(-0.5\)}]\)], "Input"],

Cell[BoxData[
    \({6.085133322838629`*^-6, {c4 \[Rule] 0.37783020307922394`, 
        c3 \[Rule] 0.13192613533448053`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(c4 = Rationalize[pmin[\([2, 1, 2]\)], 10^\(-16\)]\)], "Input"],

Cell[BoxData[
    \(69234319\/183241886\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(c3 = Rationalize[pmin[\([2, 2, 2]\)], 10^\(-16\)]\)], "Input"],

Cell[BoxData[
    \(21564835\/163461432\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(a = Simplify[a]; b = Simplify[b]; c = Simplify[c];\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(truncerror2 = Sqrt[N[Plus @@ \((TCO[a, b, c, e, 7]^2)\)]]\)], "Input"],

Cell[BoxData[
    \(0.002466806300226799`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[BCO[a, b, c, e, i], {i, 1, 6}]\)], "Input"],

Cell[BoxData[
    \({{0}, {0}, {0, 0}, {0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TCO[a, b, c, e, 7]\)], "Input"],

Cell[BoxData[
    \({6626800285057449361485553\/14161752456841416285818030736, 
      6626800285057449361485553\/14161752456841416285818030736, \
\(-\(18029079115407001\/25160504113870231680\)\), \
\(-\(18029079115407001\/33547338818493642240\)\), \
\(-\(18029079115407001\/16773669409246821120\)\), \
\(-\(18029079115407001\/100642016455480926720\)\), \
\(-\(53095034721780848715788041\/118398730119502759364047720320\)\), \
\(-\(53095034721780848715788041\/39466243373167586454682573440\)\), \
\(-\(53095034721780848715788041\/118398730119502759364047720320\)\), \
\(-\(6606041971590994593388207\/11060512532757926554846418280\)\), \
\(-\(6606041971590994593388207\/11060512532757926554846418280\)\), \
\(-\(6606041971590994593388207\/11060512532757926554846418280\)\), \
\(-\(6606041971590994593388207\/11060512532757926554846418280\)\), 
      121412118429400432801201547724793\/\
7231868869034230336024088288479107840, 
      121412118429400432801201547724793\/\
1205311478172371722670681381413184640, 
      121412118429400432801201547724793\/\
3615934434517115168012044144239553920, 
      121412118429400432801201547724793\/\
4821245912689486890682725525652738560, 
      121412118429400432801201547724793\/\
1607081970896495630227575175217579520, 
      121412118429400432801201547724793\/\
4821245912689486890682725525652738560, 
      121412118429400432801201547724793\/\
72318688690342303360240882884791078400}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(a\)], "Input"],

Cell[BoxData[
    \({{0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0}, {\(-\(566176066160816368724165\/26205783457816689201681408\)\), \
\(-\(934388454315194519838355\/26205783457816689201681408\)\), 0, 0, 
        0}, {\(-\(351799497286547349153210668272109902312409099678280028763\/\
8177328545672609359710336639166027277533103015177904966896\)\), 
        10646665816325151905174528848756141686805194879693486107\/\
1242755249642947990229878856207312116480852416498149115280, \
\(-\(915691996340309934119956177148232255826592738828464460414779254\/\
11021421301763736553850566088629369740343785847519626016049543885\)\), 0, 
        0}, {\(-\(\
633648028993686610157144618113481302138568346377672759826186407485068770691183\
87233252853994107680\/\
408136492556501060141991912456939112703373691759391189366331710175820676617182\
4737627246362002999907\)\), 
        1356084969151726181173967311981474748217064092562599463305553452964798\
8733761222958832999342645800\/\
107621561756789683298007993852741972988027263511728712126668753730912359296012\
38470119492467835927, \
\(-\(7635606382820377635224045892097189078530625186148642828728376363354131798\
86647246691637139791654239517985945571840/
            568621995405159802586331511677924208710226160234231307100997161263\
364110392358297867659173301562025194614463407693\)\), 
        7030016477281009232760550227552052010796179979832203718638408169396253\
45202826592355245726165154045317469844751200/
          10476895254862370700128929985200555749408788983305285440060009464129\
63786824881585702342255048817864247816654302473, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(b\)], "Input"],

Cell[BoxData[
    \({245280645027361617888635915055889\/13029360946012182965104101986586720,\
 1956479920215704481738000730712813\/1461800601587275202124238479362250, \
\(-\(420010922572207850490658330282366094333230753310317535232\/\
358801735598007376741932143009497424373084091199228720375\)\), 
      2640001833783734217414978774042911517924935197588787015912\/\
4053815253781288433596695586518056200229258542523445284385, 
      252289845074107912444541774596019524300622391941489375261593249432414817\
135673353593\/\
155614204776981451921363138426953001675109511815235262677333550609473903684176\
7012000}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(c\)], "Input"],

Cell[BoxData[
    \({1, 0, 21564835\/163461432, 
      69234319\/183241886, \(-\(32636179810556855\/47904901774520473\)\)}\)], \
"Output"]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 693}},
WindowSize->{867, 520},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 96, 2, 30, "Input"],
Cell[1875, 57, 82, 1, 29, "Output"]
}, Open  ]],
Cell[1972, 61, 47, 1, 30, "Input"],
Cell[2022, 64, 49, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[2096, 69, 69, 1, 30, "Input"],
Cell[2168, 72, 1309, 22, 221, "Output"]
}, Open  ]],
Cell[3492, 97, 398, 7, 90, "Input"],
Cell[3893, 106, 84, 1, 30, "Input"],
Cell[3980, 109, 155, 3, 30, "Input"],
Cell[4138, 114, 112, 2, 30, "Input"],
Cell[4253, 118, 275, 5, 45, "Input"],
Cell[4531, 125, 157, 2, 30, "Input"],
Cell[4691, 129, 435, 9, 97, "Input"],
Cell[5129, 140, 198, 3, 50, "Input"],
Cell[5330, 145, 114, 2, 30, "Input"],
Cell[5447, 149, 83, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[5555, 154, 161, 3, 30, "Input"],
Cell[5719, 159, 124, 2, 29, "Output"]
}, Open  ]],
Cell[5858, 164, 79, 1, 30, "Input"],
Cell[5940, 167, 83, 1, 30, "Input"],
Cell[6026, 170, 157, 3, 30, "Input"],
Cell[6186, 175, 1115, 30, 110, "Input"],

Cell[CellGroupData[{
Cell[7326, 209, 141, 3, 30, "Input"],
Cell[7470, 214, 56, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7563, 220, 105, 2, 30, "Input"],
Cell[7671, 224, 135, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7843, 231, 82, 1, 30, "Input"],
Cell[7928, 234, 53, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8018, 240, 82, 1, 30, "Input"],
Cell[8103, 243, 53, 1, 42, "Output"]
}, Open  ]],
Cell[8171, 247, 83, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[8279, 252, 90, 1, 30, "Input"],
Cell[8372, 255, 55, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8464, 261, 69, 1, 30, "Input"],
Cell[8536, 264, 124, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8697, 271, 51, 1, 30, "Input"],
Cell[8751, 274, 1436, 27, 280, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10224, 306, 34, 1, 30, "Input"],
Cell[10261, 309, 1600, 26, 389, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11898, 340, 34, 1, 30, "Input"],
Cell[11935, 343, 626, 10, 144, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12598, 358, 34, 1, 30, "Input"],
Cell[12635, 361, 138, 3, 42, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

